from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CoordinateTransformation3D(_message.Message):
    __slots__ = ["x", "y", "z", "roll", "pitch", "yaw"]
    X_FIELD_NUMBER: _ClassVar[int]
    Y_FIELD_NUMBER: _ClassVar[int]
    Z_FIELD_NUMBER: _ClassVar[int]
    ROLL_FIELD_NUMBER: _ClassVar[int]
    PITCH_FIELD_NUMBER: _ClassVar[int]
    YAW_FIELD_NUMBER: _ClassVar[int]
    x: float
    y: float
    z: float
    roll: float
    pitch: float
    yaw: float
    def __init__(self, x: _Optional[float] = ..., y: _Optional[float] = ..., z: _Optional[float] = ..., roll: _Optional[float] = ..., pitch: _Optional[float] = ..., yaw: _Optional[float] = ...) -> None: ...

class RequestCmd(_message.Message):
    __slots__ = ["Id", "params"]
    ID_FIELD_NUMBER: _ClassVar[int]
    PARAMS_FIELD_NUMBER: _ClassVar[int]
    Id: int
    params: CoordinateTransformation3D
    def __init__(self, Id: _Optional[int] = ..., params: _Optional[_Union[CoordinateTransformation3D, _Mapping]] = ...) -> None: ...

class Response(_message.Message):
    __slots__ = ["info"]
    INFO_FIELD_NUMBER: _ClassVar[int]
    info: str
    def __init__(self, info: _Optional[str] = ...) -> None: ...

class Image(_message.Message):
    __slots__ = ["width", "height", "channel", "encode", "data"]
    WIDTH_FIELD_NUMBER: _ClassVar[int]
    HEIGHT_FIELD_NUMBER: _ClassVar[int]
    CHANNEL_FIELD_NUMBER: _ClassVar[int]
    ENCODE_FIELD_NUMBER: _ClassVar[int]
    DATA_FIELD_NUMBER: _ClassVar[int]
    width: int
    height: int
    channel: int
    encode: bool
    data: bytes
    def __init__(self, width: _Optional[int] = ..., height: _Optional[int] = ..., channel: _Optional[int] = ..., encode: bool = ..., data: _Optional[bytes] = ...) -> None: ...

class PointCloud(_message.Message):
    __slots__ = ["size", "data"]
    SIZE_FIELD_NUMBER: _ClassVar[int]
    DATA_FIELD_NUMBER: _ClassVar[int]
    size: int
    data: bytes
    def __init__(self, size: _Optional[int] = ..., data: _Optional[bytes] = ...) -> None: ...

class LabelImage(_message.Message):
    __slots__ = ["label", "ir"]
    LABEL_FIELD_NUMBER: _ClassVar[int]
    IR_FIELD_NUMBER: _ClassVar[int]
    label: int
    ir: Image
    def __init__(self, label: _Optional[int] = ..., ir: _Optional[_Union[Image, _Mapping]] = ...) -> None: ...

class Line(_message.Message):
    __slots__ = ["begin", "end"]
    BEGIN_FIELD_NUMBER: _ClassVar[int]
    END_FIELD_NUMBER: _ClassVar[int]
    begin: int
    end: int
    def __init__(self, begin: _Optional[int] = ..., end: _Optional[int] = ...) -> None: ...

class SegBox(_message.Message):
    __slots__ = ["x", "y", "width", "height", "confidence", "lines"]
    X_FIELD_NUMBER: _ClassVar[int]
    Y_FIELD_NUMBER: _ClassVar[int]
    WIDTH_FIELD_NUMBER: _ClassVar[int]
    HEIGHT_FIELD_NUMBER: _ClassVar[int]
    CONFIDENCE_FIELD_NUMBER: _ClassVar[int]
    LINES_FIELD_NUMBER: _ClassVar[int]
    x: int
    y: int
    width: int
    height: int
    confidence: float
    lines: _containers.RepeatedCompositeFieldContainer[Line]
    def __init__(self, x: _Optional[int] = ..., y: _Optional[int] = ..., width: _Optional[int] = ..., height: _Optional[int] = ..., confidence: _Optional[float] = ..., lines: _Optional[_Iterable[_Union[Line, _Mapping]]] = ...) -> None: ...

class LabelYolo(_message.Message):
    __slots__ = ["label", "boxes"]
    LABEL_FIELD_NUMBER: _ClassVar[int]
    BOXES_FIELD_NUMBER: _ClassVar[int]
    label: int
    boxes: _containers.RepeatedCompositeFieldContainer[SegBox]
    def __init__(self, label: _Optional[int] = ..., boxes: _Optional[_Iterable[_Union[SegBox, _Mapping]]] = ...) -> None: ...

class ResImage(_message.Message):
    __slots__ = ["img1", "img2", "img3", "img4"]
    IMG1_FIELD_NUMBER: _ClassVar[int]
    IMG2_FIELD_NUMBER: _ClassVar[int]
    IMG3_FIELD_NUMBER: _ClassVar[int]
    IMG4_FIELD_NUMBER: _ClassVar[int]
    img1: Image
    img2: Image
    img3: Image
    img4: Image
    def __init__(self, img1: _Optional[_Union[Image, _Mapping]] = ..., img2: _Optional[_Union[Image, _Mapping]] = ..., img3: _Optional[_Union[Image, _Mapping]] = ..., img4: _Optional[_Union[Image, _Mapping]] = ...) -> None: ...

class ResCloud(_message.Message):
    __slots__ = ["cloud1", "cloud2", "cloud3", "cloud4"]
    CLOUD1_FIELD_NUMBER: _ClassVar[int]
    CLOUD2_FIELD_NUMBER: _ClassVar[int]
    CLOUD3_FIELD_NUMBER: _ClassVar[int]
    CLOUD4_FIELD_NUMBER: _ClassVar[int]
    cloud1: PointCloud
    cloud2: PointCloud
    cloud3: PointCloud
    cloud4: PointCloud
    def __init__(self, cloud1: _Optional[_Union[PointCloud, _Mapping]] = ..., cloud2: _Optional[_Union[PointCloud, _Mapping]] = ..., cloud3: _Optional[_Union[PointCloud, _Mapping]] = ..., cloud4: _Optional[_Union[PointCloud, _Mapping]] = ...) -> None: ...

class MeasureInfo(_message.Message):
    __slots__ = ["x", "y", "trans_x", "trans_y", "theta", "width", "wheelbase", "ftheta", "border_plc", "border_display", "error"]
    X_FIELD_NUMBER: _ClassVar[int]
    Y_FIELD_NUMBER: _ClassVar[int]
    TRANS_X_FIELD_NUMBER: _ClassVar[int]
    TRANS_Y_FIELD_NUMBER: _ClassVar[int]
    THETA_FIELD_NUMBER: _ClassVar[int]
    WIDTH_FIELD_NUMBER: _ClassVar[int]
    WHEELBASE_FIELD_NUMBER: _ClassVar[int]
    FTHETA_FIELD_NUMBER: _ClassVar[int]
    BORDER_PLC_FIELD_NUMBER: _ClassVar[int]
    BORDER_DISPLAY_FIELD_NUMBER: _ClassVar[int]
    ERROR_FIELD_NUMBER: _ClassVar[int]
    x: float
    y: float
    trans_x: float
    trans_y: float
    theta: float
    width: float
    wheelbase: float
    ftheta: float
    border_plc: int
    border_display: int
    error: str
    def __init__(self, x: _Optional[float] = ..., y: _Optional[float] = ..., trans_x: _Optional[float] = ..., trans_y: _Optional[float] = ..., theta: _Optional[float] = ..., width: _Optional[float] = ..., wheelbase: _Optional[float] = ..., ftheta: _Optional[float] = ..., border_plc: _Optional[int] = ..., border_display: _Optional[int] = ..., error: _Optional[str] = ...) -> None: ...

class ResFrame(_message.Message):
    __slots__ = ["images", "clouds", "measure_info"]
    IMAGES_FIELD_NUMBER: _ClassVar[int]
    CLOUDS_FIELD_NUMBER: _ClassVar[int]
    MEASURE_INFO_FIELD_NUMBER: _ClassVar[int]
    images: ResImage
    clouds: ResCloud
    measure_info: MeasureInfo
    def __init__(self, images: _Optional[_Union[ResImage, _Mapping]] = ..., clouds: _Optional[_Union[ResCloud, _Mapping]] = ..., measure_info: _Optional[_Union[MeasureInfo, _Mapping]] = ...) -> None: ...

class Boundary(_message.Message):
    __slots__ = ["radius", "left", "right", "buttom", "minAngle", "maxAngle", "fwheelAngle"]
    RADIUS_FIELD_NUMBER: _ClassVar[int]
    LEFT_FIELD_NUMBER: _ClassVar[int]
    RIGHT_FIELD_NUMBER: _ClassVar[int]
    BUTTOM_FIELD_NUMBER: _ClassVar[int]
    MINANGLE_FIELD_NUMBER: _ClassVar[int]
    MAXANGLE_FIELD_NUMBER: _ClassVar[int]
    FWHEELANGLE_FIELD_NUMBER: _ClassVar[int]
    radius: float
    left: float
    right: float
    buttom: float
    minAngle: float
    maxAngle: float
    fwheelAngle: float
    def __init__(self, radius: _Optional[float] = ..., left: _Optional[float] = ..., right: _Optional[float] = ..., buttom: _Optional[float] = ..., minAngle: _Optional[float] = ..., maxAngle: _Optional[float] = ..., fwheelAngle: _Optional[float] = ...) -> None: ...

class Limit(_message.Message):
    __slots__ = ["plc_limit", "display_limit", "maxWidth", "maxWheelBase"]
    PLC_LIMIT_FIELD_NUMBER: _ClassVar[int]
    DISPLAY_LIMIT_FIELD_NUMBER: _ClassVar[int]
    MAXWIDTH_FIELD_NUMBER: _ClassVar[int]
    MAXWHEELBASE_FIELD_NUMBER: _ClassVar[int]
    plc_limit: Boundary
    display_limit: Boundary
    maxWidth: float
    maxWheelBase: float
    def __init__(self, plc_limit: _Optional[_Union[Boundary, _Mapping]] = ..., display_limit: _Optional[_Union[Boundary, _Mapping]] = ..., maxWidth: _Optional[float] = ..., maxWheelBase: _Optional[float] = ...) -> None: ...
